Index: branches/world_entities/src/util/Makefile.am
===================================================================
--- branches/world_entities/src/util/Makefile.am	(revision 5622)
+++ branches/world_entities/src/util/Makefile.am	(revision 5629)
@@ -5,4 +5,5 @@
 
 libORXutils_a_SOURCES = fast_factory.cc \
+			object_manager.cc \
                         loading/factory.cc \
 			garbage_collector.cc \
@@ -18,7 +19,8 @@
 			track/pilot_node.cc \
 			track/track_manager.cc \
-			track/track_node.cc
+			track/track_node.cc 
 
 noinst_HEADERS =        fast_factory.h \
+			object_manager.h \
 			garbage_collector.h \
 			state.h \
Index: branches/world_entities/src/util/Makefile.in
===================================================================
--- branches/world_entities/src/util/Makefile.in	(revision 5622)
+++ branches/world_entities/src/util/Makefile.in	(revision 5629)
@@ -54,5 +54,6 @@
 libORXutils_a_AR = $(AR) $(ARFLAGS)
 libORXutils_a_LIBADD =
-am_libORXutils_a_OBJECTS = fast_factory.$(OBJEXT) factory.$(OBJEXT) \
+am_libORXutils_a_OBJECTS = fast_factory.$(OBJEXT) \
+	object_manager.$(OBJEXT) factory.$(OBJEXT) \
 	garbage_collector.$(OBJEXT) state.$(OBJEXT) \
 	user_control.$(OBJEXT) animation3d.$(OBJEXT) \
@@ -190,4 +191,5 @@
 noinst_LIBRARIES = libORXutils.a
 libORXutils_a_SOURCES = fast_factory.cc \
+			object_manager.cc \
                         loading/factory.cc \
 			garbage_collector.cc \
@@ -203,7 +205,8 @@
 			track/pilot_node.cc \
 			track/track_manager.cc \
-			track/track_node.cc
+			track/track_node.cc 
 
 noinst_HEADERS = fast_factory.h \
+			object_manager.h \
 			garbage_collector.h \
 			state.h \
@@ -278,4 +281,5 @@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/load_param.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/load_param_description.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/object_manager.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/pilot_node.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/resource_manager.Po@am__quote@
Index: branches/world_entities/src/util/fast_factory.cc
===================================================================
--- branches/world_entities/src/util/fast_factory.cc	(revision 5622)
+++ branches/world_entities/src/util/fast_factory.cc	(revision 5629)
@@ -13,5 +13,5 @@
 */
 
-#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_OBJECT_MANAGER
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_LOAD
 
 #include "fast_factory.h"
Index: branches/world_entities/src/util/object_manager.cc
===================================================================
--- branches/world_entities/src/util/object_manager.cc	(revision 5629)
+++ branches/world_entities/src/util/object_manager.cc	(revision 5629)
@@ -0,0 +1,43 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: ...
+   co-programmer: ...
+*/
+
+//#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD_ENTITY
+
+#include "object_manager.h"
+
+using namespace std;
+
+
+/**
+ * standard constructor
+ */
+ObjectManager::ObjectManager ()
+{
+   this->setClassID(CL_OBJECT_MANAGER, "ObjectManager");
+   this->setName("ObjectManager");
+}
+
+/**
+ *  the singleton reference to this class
+ */
+ObjectManager* ObjectManager::singletonRef = NULL;
+
+/**
+   @brief standard deconstructor
+ */
+ObjectManager::~ObjectManager ()
+{
+  ObjectManager::singletonRef = NULL;
+}
Index: branches/world_entities/src/util/object_manager.h
===================================================================
--- branches/world_entities/src/util/object_manager.h	(revision 5629)
+++ branches/world_entities/src/util/object_manager.h	(revision 5629)
@@ -0,0 +1,26 @@
+/*!
+ * @file object_manager.h
+ * @brief Definition of the ... singleton Class
+*/
+
+#ifndef _OBJECT_MANAGER_H
+#define _OBJECT_MANAGER_H
+
+#include "base_object.h"
+
+// FORWARD DECLARATION
+
+//! A default singleton class.
+class ObjectManager : public BaseObject {
+
+ public:
+  virtual ~ObjectManager(void);
+  /** @returns a Pointer to the only object of this Class */
+  inline static ObjectManager* getInstance(void) { if (!ObjectManager::singletonRef) ObjectManager::singletonRef = new ObjectManager();  return ObjectManager::singletonRef; };
+
+ private:
+  ObjectManager(void);
+  static ObjectManager* singletonRef;
+};
+
+#endif /* _OBJECT_MANAGER_H */