Index: /code/branches/libraries/src/orxonox/overlays/FadeoutText.h
===================================================================
--- /code/branches/libraries/src/orxonox/overlays/FadeoutText.h	(revision 5629)
+++ /code/branches/libraries/src/orxonox/overlays/FadeoutText.h	(revision 5630)
@@ -30,5 +30,5 @@
 #define _FadeoutText_H__
 
-#include "OrxonoxPrereqs.h"
+#include "overlays/OverlaysPrereqs.h"
 
 #include "tools/Timer.h"
@@ -38,5 +38,5 @@
 namespace orxonox
 {
-    class _OrxonoxExport FadeoutText : public OverlayText, public Tickable
+    class _OverlaysExport FadeoutText : public OverlayText, public Tickable
     {
         public:
Index: /code/branches/libraries/src/orxonox/overlays/GUIOverlay.h
===================================================================
--- /code/branches/libraries/src/orxonox/overlays/GUIOverlay.h	(revision 5629)
+++ /code/branches/libraries/src/orxonox/overlays/GUIOverlay.h	(revision 5630)
@@ -30,5 +30,5 @@
 #define _GUIOverlay_H__
 
-#include "OrxonoxPrereqs.h"
+#include "overlays/OverlaysPrereqs.h"
 
 #include <string>
@@ -37,5 +37,5 @@
 namespace orxonox
 {
-    class _OrxonoxExport GUIOverlay : public OrxonoxOverlay
+    class _OverlaysExport GUIOverlay : public OrxonoxOverlay
     {
         public:
Index: /code/branches/libraries/src/orxonox/overlays/OverlayText.h
===================================================================
--- /code/branches/libraries/src/orxonox/overlays/OverlayText.h	(revision 5629)
+++ /code/branches/libraries/src/orxonox/overlays/OverlayText.h	(revision 5630)
@@ -30,5 +30,5 @@
 #define _OverlayText_H__
 
-#include "OrxonoxPrereqs.h"
+#include "overlays/OverlaysPrereqs.h"
 
 #include <string>
@@ -39,5 +39,5 @@
 namespace orxonox
 {
-    class _OrxonoxExport OverlayText : public OrxonoxOverlay
+    class _OverlaysExport OverlayText : public OrxonoxOverlay
     {
     public:
Index: /code/branches/libraries/src/orxonox/overlays/OverlaysPrereqs.h
===================================================================
--- /code/branches/libraries/src/orxonox/overlays/OverlaysPrereqs.h	(revision 5630)
+++ /code/branches/libraries/src/orxonox/overlays/OverlaysPrereqs.h	(revision 5630)
@@ -0,0 +1,93 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+  @file
+  @brief Contains all the necessary forward declarations for all classes and structs.
+*/
+
+#ifndef _OverlaysPrereqs_H__
+#define _OverlaysPrereqs_H__
+
+#include "OrxonoxConfig.h"
+
+//-----------------------------------------------------------------------
+// Shared library settings
+//-----------------------------------------------------------------------
+#if defined(ORXONOX_PLATFORM_WINDOWS) && !defined(ORXONOX_STATIC_BUILD)
+#  ifdef OVERLAYS_SHARED_BUILD
+#    define _OverlaysExport __declspec(dllexport)
+#  else
+#    if defined( __MINGW32__ )
+#      define _OverlaysExport
+#    else
+#      define _OverlaysExport __declspec(dllimport)
+#    endif
+#  endif
+#elif defined ( ORXONOX_GCC_VISIBILITY )
+#  define _OverlaysExport  __attribute__ ((visibility("default")))
+#else
+#  define _OverlaysExport
+#endif
+
+//-----------------------------------------------------------------------
+// Forward declarations
+//-----------------------------------------------------------------------
+
+namespace orxonox
+{
+    class BarColour;
+    class DebugFPSText;
+    class DebugRTRText;
+    class GUIOverlay;
+    class HUDBar;
+    class HUDNavigation;
+    class HUDRadar;
+    class HUDSpeedBar;
+    class HUDHealthBar;
+    class HUDTimer;
+    class Notification;
+    class NotificationListener;
+    class NotificationManager;
+    class NotificationOverlay;
+    class NotificationQueue;
+    class OrxonoxOverlay;
+    class OverlayGroup;
+    class OverlayText;
+    class FadeoutText;
+    class GametypeStatus;
+    class AnnounceMessage;
+    class KillMessage;
+    class DeathMessage;
+
+    class CreateLines;
+    class Scoreboard;
+    class Stats;
+}
+
+#endif /* _OverlaysPrereqs_H__ */
Index: /code/branches/libraries/src/orxonox/overlays/debug/DebugFPSText.h
===================================================================
--- /code/branches/libraries/src/orxonox/overlays/debug/DebugFPSText.h	(revision 5629)
+++ /code/branches/libraries/src/orxonox/overlays/debug/DebugFPSText.h	(revision 5630)
@@ -30,5 +30,5 @@
 #define _DebugFPSText_H__
 
-#include "OrxonoxPrereqs.h"
+#include "overlays/OverlaysPrereqs.h"
 
 #include "interfaces/Tickable.h"
@@ -37,5 +37,5 @@
 namespace orxonox
 {
-    class _OrxonoxExport DebugFPSText : public OverlayText, public Tickable
+    class _OverlaysExport DebugFPSText : public OverlayText, public Tickable
     {
     public:
Index: /code/branches/libraries/src/orxonox/overlays/debug/DebugRTRText.h
===================================================================
--- /code/branches/libraries/src/orxonox/overlays/debug/DebugRTRText.h	(revision 5629)
+++ /code/branches/libraries/src/orxonox/overlays/debug/DebugRTRText.h	(revision 5630)
@@ -30,5 +30,5 @@
 #define _DebugRTRText_H__
 
-#include "OrxonoxPrereqs.h"
+#include "overlays/OverlaysPrereqs.h"
 
 #include "interfaces/Tickable.h"
@@ -37,5 +37,5 @@
 namespace orxonox
 {
-    class _OrxonoxExport DebugRTRText : public OverlayText, public Tickable
+    class _OverlaysExport DebugRTRText : public OverlayText, public Tickable
     {
     public:
Index: /code/branches/libraries/src/orxonox/overlays/hud/AnnounceMessage.h
===================================================================
--- /code/branches/libraries/src/orxonox/overlays/hud/AnnounceMessage.h	(revision 5629)
+++ /code/branches/libraries/src/orxonox/overlays/hud/AnnounceMessage.h	(revision 5630)
@@ -30,5 +30,5 @@
 #define _AnnounceMessage_H__
 
-#include "OrxonoxPrereqs.h"
+#include "overlays/OverlaysPrereqs.h"
 
 #include "interfaces/GametypeMessageListener.h"
@@ -37,5 +37,5 @@
 namespace orxonox
 {
-    class _OrxonoxExport AnnounceMessage : public FadeoutText, public GametypeMessageListener
+    class _OverlaysExport AnnounceMessage : public FadeoutText, public GametypeMessageListener
     {
         public:
Index: /code/branches/libraries/src/orxonox/overlays/hud/ChatOverlay.h
===================================================================
--- /code/branches/libraries/src/orxonox/overlays/hud/ChatOverlay.h	(revision 5629)
+++ /code/branches/libraries/src/orxonox/overlays/hud/ChatOverlay.h	(revision 5630)
@@ -30,5 +30,5 @@
 #define _ChatOverlay_H__
 
-#include "OrxonoxPrereqs.h"
+#include "overlays/OverlaysPrereqs.h"
 
 #include <list>
@@ -40,5 +40,5 @@
 namespace orxonox
 {
-    class _OrxonoxExport ChatOverlay : public OverlayText, public ChatListener
+    class _OverlaysExport ChatOverlay : public OverlayText, public ChatListener
     {
         public:
Index: /code/branches/libraries/src/orxonox/overlays/hud/DeathMessage.h
===================================================================
--- /code/branches/libraries/src/orxonox/overlays/hud/DeathMessage.h	(revision 5629)
+++ /code/branches/libraries/src/orxonox/overlays/hud/DeathMessage.h	(revision 5630)
@@ -30,5 +30,5 @@
 #define _DeathMessage_H__
 
-#include "OrxonoxPrereqs.h"
+#include "overlays/OverlaysPrereqs.h"
 
 #include "interfaces/GametypeMessageListener.h"
@@ -37,5 +37,5 @@
 namespace orxonox
 {
-    class _OrxonoxExport DeathMessage : public FadeoutText, public GametypeMessageListener
+    class _OverlaysExport DeathMessage : public FadeoutText, public GametypeMessageListener
     {
         public:
Index: /code/branches/libraries/src/orxonox/overlays/hud/GametypeStatus.h
===================================================================
--- /code/branches/libraries/src/orxonox/overlays/hud/GametypeStatus.h	(revision 5629)
+++ /code/branches/libraries/src/orxonox/overlays/hud/GametypeStatus.h	(revision 5630)
@@ -30,5 +30,5 @@
 #define _GametypeStatus_H__
 
-#include "OrxonoxPrereqs.h"
+#include "overlays/OverlaysPrereqs.h"
 
 #include "interfaces/Tickable.h"
@@ -37,5 +37,5 @@
 namespace orxonox
 {
-    class _OrxonoxExport GametypeStatus : public OverlayText, public Tickable
+    class _OverlaysExport GametypeStatus : public OverlayText, public Tickable
     {
         public:
Index: /code/branches/libraries/src/orxonox/overlays/hud/HUDBar.h
===================================================================
--- /code/branches/libraries/src/orxonox/overlays/hud/HUDBar.h	(revision 5629)
+++ /code/branches/libraries/src/orxonox/overlays/hud/HUDBar.h	(revision 5630)
@@ -32,5 +32,5 @@
 #define _HUDBar_H__
 
-#include "OrxonoxPrereqs.h"
+#include "overlays/OverlaysPrereqs.h"
 
 #include <map>
@@ -44,5 +44,5 @@
 namespace orxonox
 {
-    class _OrxonoxExport BarColour : public BaseObject
+    class _OverlaysExport BarColour : public BaseObject
     {
     public:
@@ -64,5 +64,5 @@
 
 
-    class _OrxonoxExport HUDBar : public OrxonoxOverlay
+    class _OverlaysExport HUDBar : public OrxonoxOverlay
     {
     public:
Index: /code/branches/libraries/src/orxonox/overlays/hud/HUDHealthBar.h
===================================================================
--- /code/branches/libraries/src/orxonox/overlays/hud/HUDHealthBar.h	(revision 5629)
+++ /code/branches/libraries/src/orxonox/overlays/hud/HUDHealthBar.h	(revision 5630)
@@ -30,5 +30,5 @@
 #define _HUDHealthBar_H__
 
-#include "OrxonoxPrereqs.h"
+#include "overlays/OverlaysPrereqs.h"
 
 #include "util/Math.h"
@@ -39,5 +39,5 @@
 namespace orxonox
 {
-    class _OrxonoxExport HUDHealthBar : public HUDBar, public Tickable
+    class _OverlaysExport HUDHealthBar : public HUDBar, public Tickable
     {
         public:
Index: /code/branches/libraries/src/orxonox/overlays/hud/HUDNavigation.h
===================================================================
--- /code/branches/libraries/src/orxonox/overlays/hud/HUDNavigation.h	(revision 5629)
+++ /code/branches/libraries/src/orxonox/overlays/hud/HUDNavigation.h	(revision 5630)
@@ -30,5 +30,5 @@
 #define _HUDNavigation_H__
 
-#include "OrxonoxPrereqs.h"
+#include "overlays/OverlaysPrereqs.h"
 
 #include "util/OgreForwardRefs.h"
@@ -38,5 +38,5 @@
 namespace orxonox
 {
-    class _OrxonoxExport HUDNavigation : public OrxonoxOverlay, public Tickable
+    class _OverlaysExport HUDNavigation : public OrxonoxOverlay, public Tickable
     {
     public:
Index: /code/branches/libraries/src/orxonox/overlays/hud/HUDRadar.h
===================================================================
--- /code/branches/libraries/src/orxonox/overlays/hud/HUDRadar.h	(revision 5629)
+++ /code/branches/libraries/src/orxonox/overlays/hud/HUDRadar.h	(revision 5630)
@@ -31,5 +31,5 @@
 #define _HUDRadar_H__
 
-#include "OrxonoxPrereqs.h"
+#include "overlays/OverlaysPrereqs.h"
 
 #include <map>
@@ -43,5 +43,5 @@
 namespace orxonox
 {
-    class _OrxonoxExport HUDRadar : public OrxonoxOverlay, public RadarListener
+    class _OverlaysExport HUDRadar : public OrxonoxOverlay, public RadarListener
     {
     public:
Index: /code/branches/libraries/src/orxonox/overlays/hud/HUDSpeedBar.h
===================================================================
--- /code/branches/libraries/src/orxonox/overlays/hud/HUDSpeedBar.h	(revision 5629)
+++ /code/branches/libraries/src/orxonox/overlays/hud/HUDSpeedBar.h	(revision 5630)
@@ -31,5 +31,5 @@
 #define _HUDSpeedBar_H__
 
-#include "OrxonoxPrereqs.h"
+#include "overlays/OverlaysPrereqs.h"
 
 #include "interfaces/Tickable.h"
@@ -38,5 +38,5 @@
 namespace orxonox
 {
-    class _OrxonoxExport HUDSpeedBar : public HUDBar, public Tickable
+    class _OverlaysExport HUDSpeedBar : public HUDBar, public Tickable
     {
     public:
Index: /code/branches/libraries/src/orxonox/overlays/hud/HUDTimer.h
===================================================================
--- /code/branches/libraries/src/orxonox/overlays/hud/HUDTimer.h	(revision 5629)
+++ /code/branches/libraries/src/orxonox/overlays/hud/HUDTimer.h	(revision 5630)
@@ -30,5 +30,5 @@
 #define _HUDTimer_H__
 
-#include "OrxonoxPrereqs.h"
+#include "overlays/OverlaysPrereqs.h"
 
 #include "interfaces/Tickable.h"
@@ -37,5 +37,5 @@
 namespace orxonox
 {
-    class _OrxonoxExport HUDTimer : public OverlayText, public Tickable
+    class _OverlaysExport HUDTimer : public OverlayText, public Tickable
     {
     public:
Index: /code/branches/libraries/src/orxonox/overlays/hud/KillMessage.h
===================================================================
--- /code/branches/libraries/src/orxonox/overlays/hud/KillMessage.h	(revision 5629)
+++ /code/branches/libraries/src/orxonox/overlays/hud/KillMessage.h	(revision 5630)
@@ -30,5 +30,5 @@
 #define _KillMessage_H__
 
-#include "OrxonoxPrereqs.h"
+#include "overlays/OverlaysPrereqs.h"
 
 #include "interfaces/GametypeMessageListener.h"
@@ -37,5 +37,5 @@
 namespace orxonox
 {
-    class _OrxonoxExport KillMessage : public FadeoutText, public GametypeMessageListener
+    class _OverlaysExport KillMessage : public FadeoutText, public GametypeMessageListener
     {
         public:
Index: /code/branches/libraries/src/orxonox/overlays/hud/PongScore.h
===================================================================
--- /code/branches/libraries/src/orxonox/overlays/hud/PongScore.h	(revision 5629)
+++ /code/branches/libraries/src/orxonox/overlays/hud/PongScore.h	(revision 5630)
@@ -30,5 +30,5 @@
 #define _PongScore_H__
 
-#include "OrxonoxPrereqs.h"
+#include "overlays/OverlaysPrereqs.h"
 
 #include "interfaces/Tickable.h"
@@ -37,5 +37,5 @@
 namespace orxonox
 {
-    class _OrxonoxExport PongScore : public OverlayText, public Tickable
+    class _OverlaysExport PongScore : public OverlayText, public Tickable
     {
         public:
Index: /code/branches/libraries/src/orxonox/overlays/hud/TeamBaseMatchScore.h
===================================================================
--- /code/branches/libraries/src/orxonox/overlays/hud/TeamBaseMatchScore.h	(revision 5629)
+++ /code/branches/libraries/src/orxonox/overlays/hud/TeamBaseMatchScore.h	(revision 5630)
@@ -30,5 +30,5 @@
 #define _TeamBaseMatchScore_H__
 
-#include "OrxonoxPrereqs.h"
+#include "overlays/OverlaysPrereqs.h"
 
 #include "interfaces/Tickable.h"
@@ -37,5 +37,5 @@
 namespace orxonox
 {
-    class _OrxonoxExport TeamBaseMatchScore : public OverlayText, public Tickable
+    class _OverlaysExport TeamBaseMatchScore : public OverlayText, public Tickable
     {
         public:
Index: /code/branches/libraries/src/orxonox/overlays/hud/UnderAttackHealthBar.h
===================================================================
--- /code/branches/libraries/src/orxonox/overlays/hud/UnderAttackHealthBar.h	(revision 5629)
+++ /code/branches/libraries/src/orxonox/overlays/hud/UnderAttackHealthBar.h	(revision 5630)
@@ -30,5 +30,5 @@
 #define _UnderAttackHealthBar_H__
 
-#include "OrxonoxPrereqs.h"
+#include "overlays/OverlaysPrereqs.h"
 
 #include "util/Math.h"
@@ -38,5 +38,5 @@
 namespace orxonox
 {
-    class _OrxonoxExport UnderAttackHealthBar : public HUDHealthBar
+    class _OverlaysExport UnderAttackHealthBar : public HUDHealthBar
     {
         public:
Index: /code/branches/libraries/src/orxonox/overlays/notifications/NotificationOverlay.h
===================================================================
--- /code/branches/libraries/src/orxonox/overlays/notifications/NotificationOverlay.h	(revision 5629)
+++ /code/branches/libraries/src/orxonox/overlays/notifications/NotificationOverlay.h	(revision 5630)
@@ -36,5 +36,5 @@
 #define _NotificationOverlay_H__
 
-#include "OrxonoxPrereqs.h"
+#include "overlays/OverlaysPrereqs.h"
 
 #include <string>
@@ -50,5 +50,5 @@
         Damian 'Mozork' Frick
     */
-    class _OrxonoxExport NotificationOverlay : public OverlayText
+    class _OverlaysExport NotificationOverlay : public OverlayText
     {
 
@@ -57,5 +57,5 @@
             NotificationOverlay(NotificationQueue* queue, Notification* notification);
             virtual ~NotificationOverlay();
-            
+
             bool processNotification(Notification* notification); //!< Processes the input Notification.
 
@@ -66,5 +66,5 @@
             inline void setFontSize(float size)
                 { this->setTextSize(size); }
-        
+
         protected:
             std::string clipMessage(const std::string & message); //!< Clips the input message if too long.
Index: /code/branches/libraries/src/orxonox/overlays/notifications/NotificationQueue.h
===================================================================
--- /code/branches/libraries/src/orxonox/overlays/notifications/NotificationQueue.h	(revision 5629)
+++ /code/branches/libraries/src/orxonox/overlays/notifications/NotificationQueue.h	(revision 5630)
@@ -35,5 +35,5 @@
 #define _NotificationOueue_H__
 
-#include "OrxonoxPrereqs.h"
+#include "overlays/OverlaysPrereqs.h"
 
 #include <ctime>
@@ -85,5 +85,5 @@
     */
 
-    class _OrxonoxExport NotificationQueue : public OverlayGroup, public Tickable, public NotificationListener
+    class _OverlaysExport NotificationQueue : public OverlayGroup, public Tickable, public NotificationListener
     {
 
Index: /code/branches/libraries/src/orxonox/overlays/stats/CreateLines.h
===================================================================
--- /code/branches/libraries/src/orxonox/overlays/stats/CreateLines.h	(revision 5629)
+++ /code/branches/libraries/src/orxonox/overlays/stats/CreateLines.h	(revision 5630)
@@ -28,9 +28,9 @@
 #define _CreateLines_H__
 
-#include "OrxonoxPrereqs.h"
+#include "overlays/OverlaysPrereqs.h"
 
 namespace orxonox
 {
-    class _OrxonoxExport CreateLines
+    class _OverlaysExport CreateLines
     {
 
Index: /code/branches/libraries/src/orxonox/overlays/stats/Scoreboard.h
===================================================================
--- /code/branches/libraries/src/orxonox/overlays/stats/Scoreboard.h	(revision 5629)
+++ /code/branches/libraries/src/orxonox/overlays/stats/Scoreboard.h	(revision 5630)
@@ -29,5 +29,5 @@
 
 
-#include "OrxonoxPrereqs.h"
+#include "overlays/OverlaysPrereqs.h"
 
 #include <string>
@@ -38,5 +38,5 @@
 namespace orxonox
 {
-    class _OrxonoxExport Scoreboard : public OrxonoxOverlay, public Tickable
+    class _OverlaysExport Scoreboard : public OrxonoxOverlay, public Tickable
     {
     public: // functions
Index: /code/branches/libraries/src/orxonox/overlays/stats/Stats.h
===================================================================
--- /code/branches/libraries/src/orxonox/overlays/stats/Stats.h	(revision 5629)
+++ /code/branches/libraries/src/orxonox/overlays/stats/Stats.h	(revision 5630)
@@ -30,5 +30,5 @@
 #define _Stats_H__
 
-#include "OrxonoxPrereqs.h"
+#include "overlays/OverlaysPrereqs.h"
 
 #include "util/OgreForwardRefs.h"
@@ -38,5 +38,5 @@
 namespace orxonox
 {
-    class _OrxonoxExport Stats : public OrxonoxOverlay, public Tickable
+    class _OverlaysExport Stats : public OrxonoxOverlay, public Tickable
     {
     public: // functions